import phm, time, math
from Tkinter import *
              
delay = 50
npoints = 200

def charge():
  global p, data, option, res_val
  if option.get() == 0:
    p.enable_set_high(3)
    p.write_outputs(0)
  else:
    p.enable_set_low(3)
    p.write_outputs(8)

  time.sleep(1)
  data = p.read_block(Npoints.get(), Delay.get(), 0)
  p.plot(data,400,300,root)
  
  max = 0.0
  for v in data:
      if max < v[1]:
          max = v[1]
  
  val = 0		# Display rough value of capacitance
  dx = 2.0
  halfV = max/2.0
  print max, halfV
  while dx < 40:
    for val in data:
      if abs(val[1] - halfV) < dx:
          try:
              r = float(res_val.get())
          except:
              msg.config(text='Error. No R')
              return
          halfT = val[0]
          print val
          c = halfT/ (r * math.log(2.0)) 
          s = '%10.6f uF ' % (c)
          msg.config(text = s)
          return
    dx = dx + 2
  
def save():
  global p, data
  p.save_data(data,'cap.dat')

def analyze():
  try:
      import pygrace
  except:
      return
  global data
  pg = pygrace.grace()
  x = []
  y = []
  for xy in data:
    x.append(xy[0])
    y.append(xy[1])
  pg.plot(x,y)
  
def bye():
    sys.exit(0)
  
p = phm.phm()
p.stop_wave()
p.select_adc(0)
p.set_adc_size(2)
data = p.read_block(2,10,0)	#dummy read
root = Tk()
p.plot(data,400,300,root)

f=Frame(root)
f.pack(side=TOP, anchor = W)

Npoints = Scale(f, label = 'Npoints', from_ = 100, to=400, resolution = 100,\
length=100,orient = HORIZONTAL)
Npoints.pack(side=LEFT, anchor = SW)
Delay = Scale(f, label = 'Delay', from_ = 10, to = 200, length=100,\
resolution = 10, orient = HORIZONTAL)
Delay.pack(side=LEFT)

option = IntVar()
Option=Checkbutton(f,text='Cha/Dis', underline = 4 , variable = option) 
Option.pack(side=LEFT, anchor = S)

b=Button(f,text='Start', command = charge)
b.pack(side=LEFT, anchor = S)

b=Button(f,text='Save', command = save)
b.pack(side=LEFT, anchor = S)

b=Button(f,text='Analyse', command = analyze)
b.pack(side=LEFT, anchor = S)

f1=Frame(root)
f1.pack(side=TOP, anchor = W, fill = BOTH)

l = Label(f1, width = 15, text = 'Enter R in Ohms')
l.pack(side=LEFT)
res_val = StringVar()
resVal=Entry(f1, width=10, bg = 'white', textvariable = res_val)
resVal.pack(side=LEFT, anchor = S)
res_val.set('1000')
l = Label(f1, width = 4, text = 'C = ')
l.pack(side=LEFT)
msg = Label(f1, width = 20, bg='white')
msg.pack(side=LEFT)

b=Button(f1,text='Quit', command = bye)
b.pack(side=RIGHT, anchor = S)

root.title('Capacitor Study')
root.mainloop()

