import phm, time, math, pygrace
from Tkinter import *

length = 15.00			# length of the rod pendulum
pisqr = math.pi * math.pi

count = 0
looping = False
NP = 5

def start():
  global root, data, looping, NP, count, length
  data = []
  count = 0
  NP = Npoints.get()
  length = Length.get()
  looping = True
  p.remove_lines()
  p.set_scale(0., 900.,NP-1, 1100.)
  root.after(1,update)

def update():
  global root, data, count, looping, NP, length
  if looping == True:
      T = p.pendulum_period(3)/1000000.0
      if T < 0:
          msg.config(text = 'period measurement timeout')
      g = 4.0 * pisqr * 2.0 * length / (3.0 *  T * T)
      s = '%2d: T = %7.5f  g = %5.1f' %( count+1, T, g)
      msg.config(text = s)
      data.append((count,g))
      count = count + 1
      
  if len(data) > 1:
    p.line(data)
  if count < NP:
    root.after(1,update)
  
def save():
  global data
  p.save_data(data, 'gravity.dat')
  
def analyze():
  global data
  pg = pygrace.grace()
  x = []
  y = []
  for xy in data:
    x.append(xy[0])
    y.append(xy[1])
  pg.plot(x,y)
  

def bye():
  sys.exit(0)
  
p=phm.phm()
root = Tk()
w = p.window(400,400,root)

cmd = Frame(root)
cmd.pack(side=TOP)

l = Label(cmd, text = 'Length=')
l.pack(side=LEFT,anchor = S)

Length = Scale(cmd, orient=HORIZONTAL, length=100,\
from_ = 10,to= 20, resolution=0.1)
Length.set(15.0)
Length.pack(side=LEFT,anchor = S)

l = Label(cmd, text = 'NPoints')
l.pack(side=LEFT,anchor = S)

Npoints = Scale(cmd, orient=HORIZONTAL, length=60,\
from_ = 5,to= 50, resolution=5)
Npoints.pack(side=LEFT,anchor = S)


p.set_scale(0., 900.,50, 1100.)
Start = Button(cmd,text = 'Start', command = start)
Start.pack(side=LEFT,anchor = S)
Save = Button(cmd,text = 'Save', command = save)
Save.pack(side=LEFT,anchor = S)

b=Button(cmd,text='Analyse', command = analyze)
b.pack(side=LEFT, anchor = S)

b=Button(cmd,text='Quit', command = bye)
b.pack(side=LEFT, anchor = S)

msg = Label(root, width = 50, bg = 'white')
msg.pack(side=LEFT,anchor = S)


root.title('Gravity using Rod Pendulum')
root.mainloop()
